Subject: [bug#43477] [PATCH 0/1] guix: graph: Add 'plain' backend.

From: zimoun <[email-masked]>
Date: Fri, 18 Sep 2020 21:59:08 +0200

Hi,

On Fri, 18 Sep 2020 at 11:36, Mathieu Othacehe <[email-masked]> wrote:

> > I am always annoyed when I use "guix graph" because most of the time I run:
> >
> >   guix graph htop | grep label
> >
> > or something along these lines.  Instead, the patch avoids the grep part:
>
> What's your exact use case? Note that you can run something like:
>
> --8<---------------cut here---------------start------------->8---
> guix gc -R `guix build htop`
> --8<---------------cut here---------------end--------------->8---
>
> to print the transitive closure of htop.

Yes, but you do not have the granularity of the option '--type'.

> > $ ./pre-inst-env guix graph -b plain htop
> > [email-masked]
> > [email-masked]
> > [email-masked]
> > [email-masked]
> > [email-masked]
> > [email-masked]
> > [email-masked]
> > [email-masked]
> > [email-masked]
> > [email-masked]
> > [email-masked]
> > [email-masked]
> > [email-masked]
> > [email-masked]
> > [email-masked]
> > [email-masked]
> > [email-masked]
>
> The issue with this approach is that the output is not really a graph,
> just a list of nodes.

It is a flattened graph. :-)

Well, my use case is: I am doing "guix graph -t <something> | grep
label" and in general then "guix graph -t <other-thing> | grep label |
grep <package>"; which is not user friendly at all.  And the output is
not friendly neither to pipe to other Guix commands.

The point is that "guix graph" is usually impractical in practise but
reads the plain "digraph" is not nice and pipe to "dot" produce
unmanageable PDF files.

Cheers,
simon